// Generated by dts-bundle-generator v8.0.1

export declare enum Ambientes {
	Producao = "PRODUCAO",
	Homologacao = "HOMOLOGACAO"
}
export interface Configuration {
	ambiente: Ambientes;
	idCorreios: string;
	codigoAcesso: string;
	contrato: string;
	cartaoPostagem?: string;
}
export declare enum CorreiosAPIs {
	Token = 5,
	Preco = 34,
	Prazo = 35,
	Cep = 41,
	Rastro = 87
}
export interface CartaoPostagem {
	api: CorreiosAPIs[];
	contrato: string;
	dr: number;
	numero: string;
}
export declare enum ServicosCorreios {
	Aerograma = "85480",
	Carta_Registrada = "10014",
	Carta_Simples = "10030",
	Carta_Social = "10022",
	Carta_ViaInternet = "68233",
	CartaFaturar_Chancela = "10065",
	CartaFaturar_SeloESe = "12556",
	CartaReg_A_FaturarMFD = "10375",
	CartaRegistra_A_Faturar = "10138",
	CartaViaInternet_Nacional = "68039",
	Cartao_Postal = "16012",
	ColetaAgendada_A_Faturar = "77895",
	Coleta_MesmoDia = "42102",
	ColetaProgramada = "42099",
	ColetaReverso_1A_Tentativa = "77968",
	ColetaReverso_2A_Tentativa = "77992",
	Correios_EntregaDireta = "31283",
	Correios_MiniEnvios = "04227",
	FAC_Registrado = "84050",
	FAC_Simples = "82031",
	Impresso_Normal = "20010",
	IndenizacaoNaoDev_MaloteG = "55255",
	IndenizacaoNaoDev_MaloteM = "55247",
	MalaDireta_BasicaEEspecial = "14010",
	MalaDireta_Domiciliária = "14036",
	Malote = "44105",
	PAC = "04510",
	PAC_GrandesFormatos = "04693",
	PacContrato = "41068",
	PacContrato_AgenciaTA = "04596",
	PacContrato_GrandFormato = "04618",
	PacContAg_PagEntTA = "04600",
	PAC_PagamentoNaEntrega = "04707",
	PacReverso_TA_Espelho_04553 = "04936",
	PacSemContrato = "4510",
	Reembolso_Postal = "43010",
	RegularizacaoObjetos_CobradosMenorPostagem = "55565",
	Remessa_Economica = "36200",
	RemessaExpressa_CRLVCRCNH = "40355",
	RemessaExpressa_TalaoCartao = "40622",
	RemessaLocal_ComComprovacaoDeEntrega = "75043",
	Sedex_SemContrato = "04014",
	Sedex10_A_Faturar = "40215",
	Sedex10Reverso_A_Faturar = "40584",
	Sedex10_SemContrato = "40215",
	Sedex12_SemContrato = "04782",
	SedexACobrar_SemContrato = "40045",
	Sedex_ComContrato_GrandesFormatos = "04138",
	Sedex_ComContrato = "40096",
	Sedex_ComContrato_40444 = "40444",
	Sedex_ComContrato_81019 = "81019",
	Sedex_ComContrato_AgenciaTA = "04553",
	Sedex_ComContrato_GrandFormato = "04537",
	Sedex_ComContrato_NovaOpcao = "40436",
	SedexContAg_PagEntTA = "04561",
	SedexHoje_A_Faturar = "40290",
	SedexHoje_Empresarial = "03662",
	SedexHoje = "04804",
	SedexHoje_SemContrato = "40290",
	SedexKit = "04200",
	SedexKit_Isencao = "04219",
	SedexReverso_TA_Espelho = "04928",
	SEDEX_COVIDAFATURAR = "03840",
	SEDEX_PagamentoNaEntrega = "04065",
	TelegramaNacional_4H_Balcao = "60070",
	TelegramaNacional_4H_FonadoPorPagina = "62081",
	TelegramaNacional_4H_GrandesClientePorPagina = "62090",
	TelegramaNacional_4H_Internet = "62170",
	TelegramaNacional_4H_InternetPorPagina = "62073",
	TelegramaNacional_4HInternet = "62170",
	TelegramaNacional_GC_Agencia = "60151",
	TelegramaNacional_GCAgencia = "60186",
	TelegramaRegularizacao = "60143"
}
declare enum TiposObjeto {
	Envelope = 1,
	Pacote = 2,
	RoloOuPrima = 3
}
export interface ConsultaPreco {
	readonly codigoProduto: ServicosCorreios | string;
	readonly cepOrigem: string;
	readonly cepDestino: string;
	readonly pesoEmGramas: number;
	readonly tipoObjeto: TiposObjeto;
	readonly larguraCm: number;
	readonly alturaCm: number;
	readonly comprimentoCm: number;
	readonly diametroCm?: number;
	readonly valorDeclarado: number;
	readonly isAvisoRecebimento: boolean;
	readonly isMaoPropria: boolean;
}
export interface Contrato {
	api: CorreiosAPIs[];
	dr: number;
	numero: string;
}
export declare class Token {
	readonly ambiente: Ambientes;
	readonly api: CorreiosAPIs[];
	readonly cartaoPostagem?: CartaoPostagem;
	readonly cie?: string;
	readonly cnpj?: string;
	readonly contrato: Contrato;
	readonly cpf?: string;
	readonly emissao: string;
	readonly expiraEm: string;
	readonly id: string;
	readonly ip: string;
	readonly paths?: string[];
	readonly perfil: "S";
	readonly pjInternacional?: number;
	readonly token: string;
	readonly zoneOffset: string;
	constructor(init: Token);
}
export declare class MessageResponse {
	readonly causa: string;
	readonly date: string;
	readonly method: string;
	readonly msgs: string[];
	readonly path: string;
	readonly stackTrace: string;
	constructor(init: MessageResponse);
}
export declare class Endereco {
	readonly cep: string;
	readonly uf: string;
	readonly localidade: string;
	readonly logradouro: string;
	readonly tipoLogradouro: string;
	readonly nomeLogradouro: string;
	readonly complemento: string;
	readonly abreviatura: string;
	readonly bairro: string;
	readonly numeroLocalidade: number;
	readonly tipoCEP: number;
	readonly cepUnidadeOperacional?: string;
	readonly lado: string;
	readonly numeroInicial?: number;
	readonly numeroFinal?: number;
	constructor(props: Endereco);
}
export declare class Rastro {
	readonly versao: string;
	readonly quantidade: number;
	readonly objetos: Objeto[];
	readonly tipoResultado: string;
	constructor(rastro: Rastro);
}
export declare enum RastroTiposResultado {
	Todos = "T",
	PrimeiroEvento = "P",
	UltimoEvento = "U"
}
export interface Objeto {
	codObjeto: string;
	tipoPostal: TipoPostal;
	largura: number;
	comprimento: number;
	altura: number;
	diametro: number;
	peso: number;
	formato: string;
	modalidade: string;
	valorDeclarado: number;
	eventos: Evento[];
}
export interface Evento {
	codigo: string;
	tipo: string;
	dtHrCriado: string;
	descricao: string;
	unidade: Unidade;
	unidadeDestino?: UnidadeDestino;
	detalhe?: string;
}
export interface Unidade {
	codSro?: string;
	tipo: string;
	endereco: UnidadeEndereco;
	nome?: string;
}
export interface UnidadeEndereco {
	cidade?: string;
	uf?: string;
	cep?: string;
	logradouro?: string;
	numero?: string;
	bairro?: string;
}
export interface UnidadeDestino {
	tipo: string;
	endereco: UnidadeDestinoEndereco;
	nome?: string;
	codSro?: string;
}
export interface UnidadeDestinoEndereco {
	cidade?: string;
	uf: string;
}
export interface TipoPostal {
	sigla: string;
	descricao: string;
	categoria: string;
}
export declare class Prazo {
	readonly coProduto: string;
	readonly dataMaxima: string;
	readonly entregaDomiciliar: string;
	readonly entregaSabado: string;
	readonly prazoEntrega: number;
	constructor(props: Prazo);
}
export declare class Preco {
	readonly coProduto: string;
	readonly pcBase: string;
	readonly pcBaseGeral: string;
	readonly peVariacao: string;
	readonly pcReferencia: string;
	readonly vlBaseCalculoImposto: string;
	readonly inPesoCubico: string;
	readonly psCobrado: string;
	readonly servicoAdicional: ServicoAdicional[];
	readonly peAdValorem: string;
	readonly vlSeguroAutomatico: string;
	readonly qtAdicional: string;
	readonly pcFaixa: string;
	readonly pcFaixaVariacao: string;
	readonly pcProduto: string;
	readonly pcTotalServicosAdicionais: string;
	readonly pcFinal: string;
	constructor(preco: Preco);
}
export interface ServicoAdicional {
	readonly coServAdicional: string;
	readonly tpServAdicional: string;
	readonly pcServicoAdicional: string;
}
declare abstract class BaseApiClient {
	protected abstract readonly CurrentApi: CorreiosAPIs;
	protected abstract readonly Endpoint: string;
	constructor();
	autentica(): Promise<Token | MessageResponse>;
	autenticaContrato(): Promise<Token | MessageResponse>;
	autenticaCartaoPostagem(): Promise<Token | MessageResponse>;
	autenticaInternal(path: string, body?: any): Promise<Token | MessageResponse>;
	protected validateToken(): Promise<void>;
	protected post(path: string, body?: any): Promise<any>;
	protected get(path: string): Promise<any>;
	private normalizeResult;
	private isToken;
	private isMessageResponse;
	private isNeedNewToken;
	private generateNewToken;
}
declare class TokenApiClient extends BaseApiClient {
	protected readonly CurrentApi: CorreiosAPIs;
	protected readonly Endpoint = "/token/v1";
}
declare class CepApiClient extends BaseApiClient {
	protected readonly CurrentApi: CorreiosAPIs;
	protected readonly Endpoint = "/cep/v2/enderecos";
	constructor();
	search(cep: string): Promise<Endereco | MessageResponse>;
	searchMany(ceps: string[]): Promise<(Endereco | MessageResponse)[] | MessageResponse>;
	private internalNormalizeResult;
}
declare class PrazoApiClient extends BaseApiClient {
	protected readonly CurrentApi: CorreiosAPIs;
	protected readonly Endpoint = "/prazo/v1";
	constructor();
	nacional(servico: ServicosCorreios, cepOrigem: string, cepDestino: string, dataEvento?: Date): Promise<Prazo | MessageResponse>;
}
declare class PrecoApiClient extends BaseApiClient {
	protected readonly CurrentApi: CorreiosAPIs;
	protected readonly Endpoint = "/preco/v1";
	constructor();
	nacional(consulta: ConsultaPreco): Promise<Preco | MessageResponse>;
}
declare class RastroApiClient extends BaseApiClient {
	protected readonly CurrentApi: CorreiosAPIs;
	protected readonly Endpoint = "/srorastro/v1/objetos";
	constructor();
	search(codigoRastreamento: string, tipoResultado?: RastroTiposResultado): Promise<Rastro | MessageResponse>;
	searchMany(codigosRastreamento: string[], tipoResultado?: RastroTiposResultado): Promise<(Rastro | MessageResponse)[] | MessageResponse>;
	private internalNormalizeResult;
}
declare class ApiClient {
	private readonly _token;
	private readonly _cep;
	private readonly _prazo;
	private readonly _preco;
	private readonly _rastro;
	get Token(): TokenApiClient;
	get Cep(): CepApiClient;
	get Prazo(): PrazoApiClient;
	get Preco(): PrecoApiClient;
	get Rastro(): RastroApiClient;
	constructor();
	initialize(init: Configuration): void;
	private checkIsInitialized;
}
declare const _default: ApiClient;

export {
	_default as default,
};

export {};
