(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global = typeof globalThis !== "undefined" ? globalThis : global || self, factory(global["correios-api-client"] = {}));
})(this, function(exports2) {
  "use strict";
  var Ambientes = /* @__PURE__ */ ((Ambientes2) => {
    Ambientes2["Producao"] = "PRODUCAO";
    Ambientes2["Homologacao"] = "HOMOLOGACAO";
    return Ambientes2;
  })(Ambientes || {});
  var CorreiosAPIs = /* @__PURE__ */ ((CorreiosAPIs2) => {
    CorreiosAPIs2[CorreiosAPIs2["Token"] = 5] = "Token";
    CorreiosAPIs2[CorreiosAPIs2["Preco"] = 34] = "Preco";
    CorreiosAPIs2[CorreiosAPIs2["Prazo"] = 35] = "Prazo";
    CorreiosAPIs2[CorreiosAPIs2["Cep"] = 41] = "Cep";
    CorreiosAPIs2[CorreiosAPIs2["Rastro"] = 87] = "Rastro";
    return CorreiosAPIs2;
  })(CorreiosAPIs || {});
  class Token {
    constructor(init) {
      this.ambiente = init.ambiente;
      this.api = init.api;
      this.cartaoPostagem = init.cartaoPostagem;
      this.cie = init.cie;
      this.cnpj = init.cnpj;
      this.contrato = init.contrato;
      this.cpf = init.cpf;
      this.emissao = init.emissao;
      this.expiraEm = init.expiraEm;
      this.id = init.id;
      this.ip = init.ip;
      this.paths = init.paths;
      this.perfil = init.perfil;
      this.pjInternacional = init.pjInternacional;
      this.token = init.token;
      this.zoneOffset = init.zoneOffset;
    }
  }
  class MessageResponse {
    constructor(init) {
      this.causa = init.causa;
      this.date = init.date;
      this.method = init.method;
      this.msgs = init.msgs;
      this.path = init.path;
      this.stackTrace = init.stackTrace;
    }
  }
  class Endereco {
    constructor(props) {
      this.cep = props.cep;
      this.uf = props.uf;
      this.localidade = props.localidade;
      this.logradouro = props.logradouro;
      this.tipoLogradouro = props.tipoLogradouro;
      this.nomeLogradouro = props.nomeLogradouro;
      this.complemento = props.complemento;
      this.abreviatura = props.abreviatura;
      this.bairro = props.bairro;
      this.numeroLocalidade = props.numeroLocalidade;
      this.tipoCEP = props.tipoCEP;
      this.cepUnidadeOperacional = props.cepUnidadeOperacional;
      this.lado = props.lado;
      this.numeroInicial = props.numeroInicial;
      this.numeroFinal = props.numeroFinal;
    }
  }
  class Rastro {
    constructor(rastro) {
      this.versao = rastro.versao;
      this.quantidade = rastro.quantidade;
      this.objetos = rastro.objetos;
      this.tipoResultado = rastro.tipoResultado;
    }
  }
  var RastroTiposResultado = /* @__PURE__ */ ((RastroTiposResultado2) => {
    RastroTiposResultado2["Todos"] = "T";
    RastroTiposResultado2["PrimeiroEvento"] = "P";
    RastroTiposResultado2["UltimoEvento"] = "U";
    return RastroTiposResultado2;
  })(RastroTiposResultado || {});
  class Prazo {
    constructor(props) {
      this.coProduto = props.coProduto;
      this.dataMaxima = props.dataMaxima;
      this.entregaDomiciliar = props.entregaDomiciliar;
      this.entregaSabado = props.entregaSabado;
      this.prazoEntrega = props.prazoEntrega;
    }
  }
  class Preco {
    constructor(preco) {
      this.coProduto = preco.coProduto;
      this.pcBase = preco.pcBase;
      this.pcBaseGeral = preco.pcBaseGeral;
      this.peVariacao = preco.peVariacao;
      this.pcReferencia = preco.pcReferencia;
      this.vlBaseCalculoImposto = preco.vlBaseCalculoImposto;
      this.inPesoCubico = preco.inPesoCubico;
      this.psCobrado = preco.psCobrado;
      this.servicoAdicional = preco.servicoAdicional;
      this.peAdValorem = preco.peAdValorem;
      this.vlSeguroAutomatico = preco.vlSeguroAutomatico;
      this.qtAdicional = preco.qtAdicional;
      this.pcFaixa = preco.pcFaixa;
      this.pcFaixaVariacao = preco.pcFaixaVariacao;
      this.pcProduto = preco.pcProduto;
      this.pcTotalServicosAdicionais = preco.pcTotalServicosAdicionais;
      this.pcFinal = preco.pcFinal;
    }
  }
  var ServicosCorreios = /* @__PURE__ */ ((ServicosCorreios2) => {
    ServicosCorreios2["Aerograma"] = "85480";
    ServicosCorreios2["Carta_Registrada"] = "10014";
    ServicosCorreios2["Carta_Simples"] = "10030";
    ServicosCorreios2["Carta_Social"] = "10022";
    ServicosCorreios2["Carta_ViaInternet"] = "68233";
    ServicosCorreios2["CartaFaturar_Chancela"] = "10065";
    ServicosCorreios2["CartaFaturar_SeloESe"] = "12556";
    ServicosCorreios2["CartaReg_A_FaturarMFD"] = "10375";
    ServicosCorreios2["CartaRegistra_A_Faturar"] = "10138";
    ServicosCorreios2["CartaViaInternet_Nacional"] = "68039";
    ServicosCorreios2["Cartao_Postal"] = "16012";
    ServicosCorreios2["ColetaAgendada_A_Faturar"] = "77895";
    ServicosCorreios2["Coleta_MesmoDia"] = "42102";
    ServicosCorreios2["ColetaProgramada"] = "42099";
    ServicosCorreios2["ColetaReverso_1A_Tentativa"] = "77968";
    ServicosCorreios2["ColetaReverso_2A_Tentativa"] = "77992";
    ServicosCorreios2["Correios_EntregaDireta"] = "31283";
    ServicosCorreios2["Correios_MiniEnvios"] = "04227";
    ServicosCorreios2["FAC_Registrado"] = "84050";
    ServicosCorreios2["FAC_Simples"] = "82031";
    ServicosCorreios2["Impresso_Normal"] = "20010";
    ServicosCorreios2["IndenizacaoNaoDev_MaloteG"] = "55255";
    ServicosCorreios2["IndenizacaoNaoDev_MaloteM"] = "55247";
    ServicosCorreios2["MalaDireta_BasicaEEspecial"] = "14010";
    ServicosCorreios2["MalaDireta_Domiciliária"] = "14036";
    ServicosCorreios2["Malote"] = "44105";
    ServicosCorreios2["PAC"] = "04510";
    ServicosCorreios2["PAC_GrandesFormatos"] = "04693";
    ServicosCorreios2["PacContrato"] = "41068";
    ServicosCorreios2["PacContrato_AgenciaTA"] = "04596";
    ServicosCorreios2["PacContrato_GrandFormato"] = "04618";
    ServicosCorreios2["PacContAg_PagEntTA"] = "04600";
    ServicosCorreios2["PAC_PagamentoNaEntrega"] = "04707";
    ServicosCorreios2["PacReverso_TA_Espelho_04553"] = "04936";
    ServicosCorreios2["PacSemContrato"] = "4510";
    ServicosCorreios2["Reembolso_Postal"] = "43010";
    ServicosCorreios2["RegularizacaoObjetos_CobradosMenorPostagem"] = "55565";
    ServicosCorreios2["Remessa_Economica"] = "36200";
    ServicosCorreios2["RemessaExpressa_CRLVCRCNH"] = "40355";
    ServicosCorreios2["RemessaExpressa_TalaoCartao"] = "40622";
    ServicosCorreios2["RemessaLocal_ComComprovacaoDeEntrega"] = "75043";
    ServicosCorreios2["Sedex_SemContrato"] = "04014";
    ServicosCorreios2["Sedex10_A_Faturar"] = "40215";
    ServicosCorreios2["Sedex10Reverso_A_Faturar"] = "40584";
    ServicosCorreios2["Sedex10_SemContrato"] = "40215";
    ServicosCorreios2["Sedex12_SemContrato"] = "04782";
    ServicosCorreios2["SedexACobrar_SemContrato"] = "40045";
    ServicosCorreios2["Sedex_ComContrato_GrandesFormatos"] = "04138";
    ServicosCorreios2["Sedex_ComContrato"] = "40096";
    ServicosCorreios2["Sedex_ComContrato_40444"] = "40444";
    ServicosCorreios2["Sedex_ComContrato_81019"] = "81019";
    ServicosCorreios2["Sedex_ComContrato_AgenciaTA"] = "04553";
    ServicosCorreios2["Sedex_ComContrato_GrandFormato"] = "04537";
    ServicosCorreios2["Sedex_ComContrato_NovaOpcao"] = "40436";
    ServicosCorreios2["SedexContAg_PagEntTA"] = "04561";
    ServicosCorreios2["SedexHoje_A_Faturar"] = "40290";
    ServicosCorreios2["SedexHoje_Empresarial"] = "03662";
    ServicosCorreios2["SedexHoje"] = "04804";
    ServicosCorreios2["SedexHoje_SemContrato"] = "40290";
    ServicosCorreios2["SedexKit"] = "04200";
    ServicosCorreios2["SedexKit_Isencao"] = "04219";
    ServicosCorreios2["SedexReverso_TA_Espelho"] = "04928";
    ServicosCorreios2["SEDEX_COVIDAFATURAR"] = "03840";
    ServicosCorreios2["SEDEX_PagamentoNaEntrega"] = "04065";
    ServicosCorreios2["TelegramaNacional_4H_Balcao"] = "60070";
    ServicosCorreios2["TelegramaNacional_4H_FonadoPorPagina"] = "62081";
    ServicosCorreios2["TelegramaNacional_4H_GrandesClientePorPagina"] = "62090";
    ServicosCorreios2["TelegramaNacional_4H_Internet"] = "62170";
    ServicosCorreios2["TelegramaNacional_4H_InternetPorPagina"] = "62073";
    ServicosCorreios2["TelegramaNacional_4HInternet"] = "62170";
    ServicosCorreios2["TelegramaNacional_GC_Agencia"] = "60151";
    ServicosCorreios2["TelegramaNacional_GCAgencia"] = "60186";
    ServicosCorreios2["TelegramaRegularizacao"] = "60143";
    return ServicosCorreios2;
  })(ServicosCorreios || {});
  const UrlApi = "https://api.correios.com.br";
  const UrlApiHomologacao = "https://apihom.correios.com.br";
  class ConfigSingleton {
    constructor() {
      this._isInitialized = false;
    }
    /**
     * The contract number used for making requests to the Correios API.
     * @throws An error if the contract has not been initialized with the `config.initialize` method.
     */
    get contrato() {
      this.checkIsInitialized();
      if (!this._contrato)
        throw new Error("O contrato não foi inicializado, utilize o método config.initialize");
      return this._contrato;
    }
    /**
     * Gets the Cartão de Postagem (posting card) number associated with the Correios account.
     * 
     * @returns The Cartão de Postagem number, or `null` if it has not been set.
     * @throws {Error} If the client has not been initialized yet.
     */
    get CartaoPostagem() {
      this.checkIsInitialized();
      return this._cartaoPostagem ?? null;
    }
    /**
     * Returns the URL of the API to be used based on the current environment.
     * @returns The URL of the API.
     */
    get urlApi() {
      this.checkIsInitialized();
      return this.ambiente == Ambientes.Producao ? UrlApi : UrlApiHomologacao;
    }
    /**
     * Returns the basic authentication string for the Correios API client.
     * @throws {Error} If the authentication settings have not been initialized.
     * @returns {string} The basic authentication string.
     */
    get basicAuth() {
      this.checkIsInitialized();
      if (!this.idCorreios || !this.codigoAcesso)
        throw new Error("As configurações de autenticação não foram inicializadas, utilize o método config.initialize");
      return `Basic ${Buffer.from(`${this.idCorreios}:${this.codigoAcesso}`).toString("base64")}`;
    }
    /**
     * Returns the last token used to authenticate with the Correios API.
     * If no token has been set, returns null.
     * @returns {Token | null} The last token used to authenticate with the Correios API, or null if no token has been set.
     */
    get lastToken() {
      this.checkIsInitialized();
      return this._lastToken ?? null;
    }
    /**
     * Initializes the configuration object with the provided values.
     * @param init - The configuration object to initialize with.
     */
    initialize(init) {
      this.ambiente = init.ambiente;
      this.idCorreios = init.idCorreios;
      this.codigoAcesso = init.codigoAcesso;
      this._cartaoPostagem = init.cartaoPostagem;
      this._contrato = init.contrato;
      this._isInitialized = true;
    }
    /**
     * Checks if the configuration for Correios API client has been initialized.
     * Throws an error if it has not been initialized.
     */
    checkIsInitialized() {
      if (!this._isInitialized)
        throw new Error("As configuração dos correios não foi inicializada, utilize o método config.initialize");
    }
    /**
     * Sets the last token used for authentication.
     * @param token The token to set.
     * @throws An error if the token is not defined.
     */
    setLastToken(token) {
      if (!token)
        throw new Error("Token is not defined");
      this._lastToken = token;
    }
  }
  class Config {
    get urlApi() {
      return Config.instance.urlApi;
    }
    get basicAuth() {
      return Config.instance.basicAuth;
    }
    get contrato() {
      return Config.instance.contrato;
    }
    get cartaoPostagem() {
      return Config.instance.CartaoPostagem;
    }
    get lastToken() {
      return Config.instance.lastToken;
    }
    constructor() {
      if (!Config.instance) {
        Config.instance = new ConfigSingleton();
      }
    }
    initialize(init) {
      Config.instance.initialize(init);
    }
    checkIsInitialized() {
      Config.instance.checkIsInitialized();
    }
    setLastToken(token) {
      Config.instance.setLastToken(token);
    }
  }
  const config = new Config();
  class HttpClient {
    /**
     * Sends a POST request to the specified URL with the given authorization and body.
     * @param url - The URL to send the request to.
     * @param authorization - The authorization header to include in the request.
     * @param body - The body of the request.
     * @returns A Promise that resolves with the response data.
     */
    static async post(url, authorization, body) {
      return HttpClient.requestInternal("POST", url, authorization, body);
    }
    /**
     * Sends a GET request to the specified URL with the given authorization and optional request body.
     * @param url The URL to send the request to.
     * @param authorization The authorization header value to include in the request.
     * @param body The optional request body to include in the request.
     * @returns A Promise that resolves with the response data of type T.
     */
    static async get(url, authorization, body) {
      return HttpClient.requestInternal("GET", url, authorization, body);
    }
    static async requestInternal(method, url, authorization, body) {
      const request = HttpClient.getRequest(method, authorization, body);
      const response = await fetch(url, request);
      const result = await response.json();
      return result;
    }
    static getRequest(method, authorization, body) {
      const request = {
        method,
        headers: {
          "Accept": "application/json",
          "Accept-Language": "pt-BR",
          "Authorization": authorization
        }
      };
      if (body != null) {
        request.headers = {
          ...request.headers,
          "Content-Type": "application/json"
        };
        request.body = JSON.stringify(body);
      }
      return request;
    }
  }
  class BaseApiClient {
    constructor() {
    }
    /**
     * Generates a token for API access.
     * @returns A Promise that resolves to a Token object if the authentication is successful, or a MessageResponse object if there was an error.
     */
    async autentica() {
      config.checkIsInitialized();
      return this.autenticaInternal(`/autentica`);
    }
    /**
     * Generates a token for accessing APIs that require authorization by contract number.
     * @returns A promise that resolves with a Token object or a MessageResponse object.
     */
    async autenticaContrato() {
      const numero = config.contrato;
      const body = {
        numero
      };
      return this.autenticaInternal(`/autentica/contrato`, body);
    }
    /**
     * Generates a token for accessing APIs that require authorization by postcard.
     * @returns A promise that resolves to a Token object or a MessageResponse object if an error occurs.
     * @throws An error if the postcard is not configured.
     */
    async autenticaCartaoPostagem() {
      const numero = config.cartaoPostagem;
      if (numero == null)
        throw new Error("Postcard not configured");
      const body = {
        numero
      };
      return this.autenticaInternal(`/autentica/cartaopostagem`, body);
    }
    /**
     * Authenticates the user and returns a token or a message response.
     * @param path - The path to authenticate the user.
     * @param body - The body of the request.
     * @returns A promise that resolves to a Token object or a MessageResponse object.
     */
    async autenticaInternal(path, body) {
      const result = await this.post(`${TokenEndpoint}${path}`, body);
      if (result instanceof Token) {
        config.setLastToken(result);
        if (this.CurrentApi !== CorreiosAPIs.Token && result.api != null && result.api.indexOf(this.CurrentApi) == -1)
          console.error("The Cep API is not authorized in the current token");
      }
      return result;
    }
    /**
     * Validates the token for the specified API. If a new token is needed, it will be obtained by calling the `autenticaContrato` method.
     * @param apiId The ID of the API to validate the token for.
     */
    async validateToken() {
      if (this.isNeedNewToken())
        await this.generateNewToken();
    }
    /**
     * Sends a POST request to the API to authenticate and generate a token.
     * @param path The path to the API endpoint.
     * @param body The request body.
     * @returns A Promise that resolves to a Token object if the authentication is successful, or a MessageResponse object if there was an error.
     */
    async post(path, body) {
      try {
        const fullUrl = `${config.urlApi}${path}`;
        const result = await HttpClient.post(fullUrl, config.basicAuth, body);
        return this.normalizeResult(result);
      } catch (erro) {
        return new MessageResponse({
          msgs: [erro.message ?? "Unknown catch error"],
          path,
          method: "POST",
          date: (/* @__PURE__ */ new Date()).toISOString(),
          causa: "Catch error",
          stackTrace: erro.stackTrace
        });
      }
    }
    /**
     * Sends a GET request to the specified URL with the authorization token.
     * @param fullUrl - The full URL to send the GET request to.
     * @returns A Promise that resolves with the response data of type T.
     * @throws An error if the token is not defined or the Cep API is not authorized in the current token.
     */
    async get(path) {
      await this.validateToken();
      const lastToken = config.lastToken;
      if (lastToken == null || lastToken.token == null)
        throw new Error("Token is not defined");
      try {
        const fullUrl = `${config.urlApi}${path}`;
        const bearerToken = `Bearer ${lastToken.token}`;
        const result = await HttpClient.get(fullUrl, bearerToken);
        return this.normalizeResult(result);
      } catch (erro) {
        return new MessageResponse({
          msgs: [erro?.message ?? "Unknown catch error"],
          path,
          method: "POST",
          date: (/* @__PURE__ */ new Date()).toISOString(),
          causa: "Catch error",
          stackTrace: erro.stackTrace
        });
      }
    }
    /**
     * Normalizes the result of an API call by checking if it's a token or message response.
     * If it's a token, returns a new Token instance.
     * If it's a message response, returns a new MessageResponse instance.
     * Otherwise, returns the original result.
     * @param result - The result of an API call.
     * @returns The normalized result.
     */
    normalizeResult(result) {
      if (this.isToken(result))
        return new Token(result);
      if (this.isMessageResponse(result))
        return new MessageResponse(result);
      return result;
    }
    /**
     * Checks if the object is a Token.
     * @param obj The object to check.
     * @returns True if the object is a Token, false otherwise.
     */
    isToken(obj) {
      return obj.token !== void 0;
    }
    /**
     * Checks if the object is a MessageResponse.
     * @param obj The object to check.
     * @returns True if the object is a MessageResponse, false otherwise.
     */
    isMessageResponse(obj) {
      return obj.msgs !== void 0;
    }
    /**
     * Determines whether a new token is needed for the specified API.
     * @param apiId The ID of the API to check.
     * @returns True if a new token is needed, false otherwise.
     */
    isNeedNewToken() {
      return config.lastToken == null || config.lastToken.expiraEm == null || new Date(config.lastToken.expiraEm) < /* @__PURE__ */ new Date() || config.lastToken.api?.indexOf(this.CurrentApi) == -1;
    }
    /**
     * Generates a new token for authentication.
     * If a cartaoPostagem is set in the config, it will authenticate using that.
     * If a contrato is set in the config, it will authenticate using that.
     * Otherwise, it will authenticate using the default credentials.
     */
    async generateNewToken() {
      config.checkIsInitialized();
      if (config.cartaoPostagem != null) {
        console.log("autenticaCartaoPostagem");
        await this.autenticaCartaoPostagem();
        return;
      }
      if (config.contrato != null) {
        console.log("autenticaContrato");
        await this.autenticaContrato();
      }
      console.log("autentica");
      await this.autentica();
    }
  }
  const TokenEndpoint = "/token/v1";
  class TokenApiClient extends BaseApiClient {
    constructor() {
      super(...arguments);
      this.CurrentApi = CorreiosAPIs.Token;
      this.Endpoint = TokenEndpoint;
    }
  }
  class CepApiClient extends BaseApiClient {
    constructor() {
      super();
      this.CurrentApi = CorreiosAPIs.Cep;
      this.Endpoint = "/cep/v2/enderecos";
    }
    /**
     * Searches for an address by CEP.
     * @param cep The CEP to search for.
     * @returns A promise that resolves to the address associated with the given CEP.
     */
    async search(cep) {
      const result = await this.get(`${this.Endpoint}/${cep}`);
      return this.internalNormalizeResult(result);
    }
    /**
     * Searches for multiple addresses by CEP.
     * @param ceps An array of CEPs to search for.
     * @returns A promise that resolves to an array of addresses associated with the given CEPs.
     */
    async searchMany(ceps) {
      const query = ceps.map((cep) => `cep=${cep}`).join("&");
      const path = `${this.Endpoint}?${query}`;
      const result = await this.get(path);
      if (result instanceof MessageResponse)
        return result;
      const itens = result.itens;
      if (Array.isArray(itens)) {
        return itens.map((item) => this.internalNormalizeResult(item));
      }
      return result;
    }
    internalNormalizeResult(result) {
      if (result instanceof MessageResponse)
        return result;
      if (result.logradouro != null)
        return new Endereco(result);
      return new MessageResponse({
        msgs: ["Result is invalid.", `Type of result: ${typeof result} `],
        method: "GET",
        path: `${this.Endpoint}`,
        stackTrace: "",
        date: (/* @__PURE__ */ new Date()).toISOString(),
        causa: ""
      });
    }
  }
  class DateUtil {
    static format(date, format) {
      if (date == null)
        return "";
      if (format == null)
        return date.toISOString();
      const day = date.getDate();
      const month = date.getMonth() + 1;
      const year = date.getFullYear();
      const hours = date.getHours();
      const minutes = date.getMinutes();
      const seconds = date.getSeconds();
      return format.replace("dd", day.toString().padStart(2, "0")).replace("MM", month.toString().padStart(2, "0")).replace("yyyy", year.toString()).replace("HH", hours.toString().padStart(2, "0")).replace("mm", minutes.toString().padStart(2, "0")).replace("ss", seconds.toString().padStart(2, "0"));
    }
  }
  class PrazoApiClient extends BaseApiClient {
    constructor() {
      super();
      this.CurrentApi = CorreiosAPIs.Cep;
      this.Endpoint = "/prazo/v1";
    }
    /**
     * Retrieves the estimated delivery time for a national shipment.
     * @param servico The type of service to be used for the shipment.
     * @param cepOrigem The origin zip code for the shipment.
     * @param cepDestino The destination zip code for the shipment.
     * @param dataEvento The date of the event for which the estimated delivery time is being calculated. Defaults to the current date.
     * @returns A promise that resolves to an Endereco object containing the estimated delivery time.
     */
    async nacional(servico, cepOrigem, cepDestino, dataEvento = /* @__PURE__ */ new Date()) {
      const dataEventoFormata = DateUtil.format(dataEvento, "dd-MM-yyyy");
      const query = `cepOrigem=${cepOrigem}&cepDestino=${cepDestino}&dtEvento=${dataEventoFormata}`;
      const result = await this.get(`${this.Endpoint}/nacional/${servico}?${query}`);
      if (result instanceof MessageResponse) {
        return result;
      }
      return new Prazo(result);
    }
  }
  var ServicosAdicionais = /* @__PURE__ */ ((ServicosAdicionais2) => {
    ServicosAdicionais2["AvisoRecebimento"] = "001";
    ServicosAdicionais2["MaoPropria"] = "002";
    ServicosAdicionais2["ValorDeclarado"] = "019";
    ServicosAdicionais2["ValorDeclaradoPac"] = "064";
    return ServicosAdicionais2;
  })(ServicosAdicionais || {});
  var TiposObjeto = /* @__PURE__ */ ((TiposObjeto2) => {
    TiposObjeto2[TiposObjeto2["Envelope"] = 1] = "Envelope";
    TiposObjeto2[TiposObjeto2["Pacote"] = 2] = "Pacote";
    TiposObjeto2[TiposObjeto2["RoloOuPrima"] = 3] = "RoloOuPrima";
    return TiposObjeto2;
  })(TiposObjeto || {});
  class TextUtil {
    static getOnlyNumbers(text) {
      return text.replace(/\D/g, "");
    }
  }
  class PrecoApiClient extends BaseApiClient {
    constructor() {
      super();
      this.CurrentApi = CorreiosAPIs.Cep;
      this.Endpoint = "/preco/v1";
    }
    /**
     * Calculates the national shipping price based on the provided parameters.
     * @param consulta - The object containing the parameters for the shipping calculation.
     * @returns A Promise that resolves to a Preco object containing the calculated price, or a MessageResponse object if an error occurred.
     */
    async nacional(consulta) {
      const cepOrigem = TextUtil.getOnlyNumbers(consulta.cepOrigem);
      const cepDestino = TextUtil.getOnlyNumbers(consulta.cepDestino);
      const valorDeclarado = consulta.valorDeclarado?.toLocaleString("pt-BR") ?? "0";
      const pesoEmGramas = consulta.pesoEmGramas?.toLocaleString("pt-BR") ?? "0";
      const tipoObjeto = consulta.tipoObjeto?.toString() ?? TiposObjeto.Pacote;
      const larguraCm = consulta.larguraCm?.toLocaleString("pt-BR") ?? "0";
      const alturaCm = consulta.alturaCm?.toLocaleString("pt-BR") ?? "0";
      const dtEvento = DateUtil.format(/* @__PURE__ */ new Date(), "dd-MM-yyyy");
      const parametros = /* @__PURE__ */ new Map([
        ["cepOrigem", cepOrigem],
        ["cepDestino", cepDestino],
        ["psObjeto", pesoEmGramas],
        ["tpObjeto", tipoObjeto],
        ["largura", larguraCm],
        ["altura", alturaCm],
        ["vlDeclarado", valorDeclarado],
        ["dtEvento", dtEvento]
      ]);
      if (consulta.tipoObjeto == TiposObjeto.RoloOuPrima) {
        const diametroCm = consulta.diametroCm?.toLocaleString("pt-BR") ?? "0";
        parametros.set("diametro", diametroCm);
      } else {
        const comprimentoCm = consulta.comprimentoCm?.toLocaleString("pt-BR") ?? "0";
        parametros.set("comprimento", comprimentoCm);
      }
      if (consulta.isAvisoRecebimento)
        parametros.set("servicosAdicionais", ServicosAdicionais.AvisoRecebimento);
      if (consulta.isMaoPropria)
        parametros.set("servicosAdicionais", ServicosAdicionais.MaoPropria);
      if (consulta.valorDeclarado > 0)
        parametros.set("servicosAdicionais", ServicosAdicionais.ValorDeclarado);
      const query = Array.from(parametros, ([key, val]) => `${key}=${val}`).join("&");
      const codServico = consulta.codigoProduto;
      const result = await this.get(`${this.Endpoint}/nacional/${codServico}?${query}`);
      if (result instanceof MessageResponse) {
        return result;
      }
      return new Preco(result);
    }
  }
  class RastroApiClient extends BaseApiClient {
    constructor() {
      super();
      this.CurrentApi = CorreiosAPIs.Cep;
      this.Endpoint = "/srorastro/v1/objetos";
    }
    async search(codigoRastreamento, tipoResultado = RastroTiposResultado.Todos) {
      const result = await this.get(`${this.Endpoint}/${codigoRastreamento}?resultado=${tipoResultado}`);
      return this.internalNormalizeResult(result);
    }
    async searchMany(codigosRastreamento, tipoResultado = RastroTiposResultado.Todos) {
      const query = codigosRastreamento.map((cep) => `codigosObjetos=${cep}`).join("&");
      const path = `${this.Endpoint}?${query}&resultado=${tipoResultado}`;
      const result = await this.get(path);
      if (result instanceof MessageResponse)
        return result;
      const itens = result.itens;
      if (Array.isArray(itens)) {
        return itens.map((item) => this.internalNormalizeResult(item));
      }
      return result;
    }
    internalNormalizeResult(result) {
      if (result instanceof MessageResponse)
        return result;
      if (result.objetos != null)
        return new Rastro(result);
      return new MessageResponse({
        msgs: ["Result is invalid.", `Type of result: ${typeof result} `],
        method: "GET",
        path: `${this.Endpoint}`,
        stackTrace: "",
        date: (/* @__PURE__ */ new Date()).toISOString(),
        causa: ""
      });
    }
  }
  class ApiClient {
    get Token() {
      this.checkIsInitialized();
      return this._token;
    }
    get Cep() {
      this.checkIsInitialized();
      return this._cep;
    }
    get Prazo() {
      this.checkIsInitialized();
      return this._prazo;
    }
    get Preco() {
      this.checkIsInitialized();
      return this._preco;
    }
    get Rastro() {
      this.checkIsInitialized();
      return this._rastro;
    }
    constructor() {
      this._token = new TokenApiClient();
      this._cep = new CepApiClient();
      this._prazo = new PrazoApiClient();
      this._preco = new PrecoApiClient();
      this._rastro = new RastroApiClient();
    }
    initialize(init) {
      config.initialize(init);
    }
    checkIsInitialized() {
      config.checkIsInitialized();
    }
  }
  const index = new ApiClient();
  exports2.Ambientes = Ambientes;
  exports2.CorreiosAPIs = CorreiosAPIs;
  exports2.Endereco = Endereco;
  exports2.MessageResponse = MessageResponse;
  exports2.Prazo = Prazo;
  exports2.Preco = Preco;
  exports2.Rastro = Rastro;
  exports2.RastroTiposResultado = RastroTiposResultado;
  exports2.ServicosCorreios = ServicosCorreios;
  exports2.Token = Token;
  exports2.default = index;
  Object.defineProperties(exports2, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
});
//# sourceMappingURL=index.umd.js.map
